#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "emd.h"
#include "..\common.h"
#include "..\extern.h"

int EMD_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0xD2, 1, -8, id );

	if( memcmp( id, "FMD", 3 ) != 0 )
	{
		if( memcmp( id, "EMD", 3 ) != 0 )
		{
			printf( MES[MES_DRVNOTFOUND], DRIVER_name );
			return 1;
		}
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int EMD_load( char *filename )
{
	long	filesize;

	filesize = _filesize( filename );
	if( filesize == -1 ) return 1;

	/* Music : DS:DX */
	r.h.ah = 0x01;
	sr.ds  = FP_SEG( filename );
	r.x.dx = FP_OFF( filename );
	int86x( 0xD2, &r, &ro, &sr );

	printf( INFO[INFO_LOAD], filename, filesize );

	return 0;
}

int EMD_play( char *opt1, char *opt2 )
{
	r.h.ah = 0x03;
	r.x.cx = 0xFFFF;
	int86x( 0xD2, &r, &ro, &sr );

	return 0;
}

int EMD_stop( void )
{
	r.h.ah = 0x00;
	int86x( 0xD2, &r, &ro, &sr );

	return 0;
}

int EMD_fade( void )
{
	r.h.ah = 0x04;
	r.h.ch = 0x3F;
	r.h.cl = 0xFF;
	int86x( 0xD2, &r, &ro, &sr );

	return 0;
}
