#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <memory.h>

#include "exmus.h"
#include "..\common.h"
#include "..\extern.h"

unsigned char	EXMUS_mode = 0;

int EXMUS_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0x50, 0, 2, id );

	if( memcmp( id, "SAMPLEID", 7 ) != 0 )
	{
		if( memcmp( id, "HDMUSID", 7 ) != 0 )
		{
			printf( MES[MES_DRVNOTFOUND], DRIVER_name );
			return 1;
		}
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int EXMUS_load( char *filename )
{
	if( strcmpi( filename, OPT[OPT_SE] ) == 0 ) EXMUS_mode = 0x02;
	else if( strcmpi( filename, OPT[OPT_MUSIC] ) == 0 ) EXMUS_mode = 0x01;
	else EXMUS_mode = 0x01;

	return 0;
}

int EXMUS_play( char *opt1, char *opt2 )
{
	if( strcmpi( opt1, OPT[OPT_SELECTOR] ) == 0 )
	{
		EXMUS_selector();
		return 0;
	}

	if( opt1 == NULL ) r.h.al = 0x00;
	else r.h.al = atoi( opt1 );

	r.h.ah = EXMUS_mode;
	int86x( 0x50, &r, &ro, &sr );

	printf( INFO[INFO_NO], r.h.al );

	return 0;
}

int EXMUS_fade( void )
{
	r.h.ah = 0x05;
	r.h.al = 0x00;
	r.x.dx = 0x0080;
	int86x( 0x50, &r, &ro, &sr );

	return 0;
}

int EXMUS_selector( void )
{
	int		no;
	char	buf[3];

	no = 0;

	for( ;; )
	{
		switch( getch())
		{
			case 0x0A:	/* DOWN */
				if( no > 0 ) no--;
				printf( INFO[INFO_NO], no );
				break;
			case 0x0B:	/* UP */
				if( no < 255 ) no++;
				printf( INFO[INFO_NO], no );
				break;
			case 0x0D:	/* ENTER */
				sprintf( buf, "%d", no );
				EXMUS_fade();
				EXMUS_play( buf, NULL );
				break;
			case 0x1B:	/* ESC */
				return 0;
			default: break;
		}
	}
}
