#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "mfm.h"
#include "..\common.h"
#include "..\extern.h"
#include "..\gmpv4sp.h"

long	MFM_size = 0;

int MFM_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0xD2, 1, 0x0103, id );

	if( memcmp( id, "MFM ", 4 ) != 0 )
	{
		if( memcmp( id, "MIDI ", 5 ) != 0 )
		{
			printf( MES[MES_DRVNOTFOUND], DRIVER_name );
			return 1;
		}
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int MFM_load( char *filename )
{
	MFM_size = GMPV4SP_load( filename, 0, 0, 1 );
	if( MFM_size == -1 ) return 1;

	return 0;
}

int MFM_play( char *opt1, char *opt2 )
{
	GMPV4SP_address( &seg, &off, 0 );

	if( strcmpi( opt1, OPT[OPT_FM] ) == 0 )
	{
		/* Music : BX:DX */
		r.h.al = 0x01;
		r.x.bx = seg;
		r.x.cx = ( unsigned short )MFM_size;
		r.x.dx = off;
	} else if( strcmpi( opt1, OPT[OPT_MIDI] ) == 0 )
	{
		r.h.ah = 0x01;
		r.h.al = 0x0E;
		int86x( 0xD2, &r, &ro, &sr );

		/* Music : BX:DX */
		r.h.al = 0x01;
		r.x.bx = seg;
		r.x.cx = ( unsigned short )MFM_size;
		r.x.dx = off;
	}

	int86x( 0xD2, &r, &ro, &sr );

	return 0;
}

int MFM_stop( void )
{
	r.h.al = 0x03;
	int86x( 0xD2, &r, &ro, &sr );

	r.h.al = 0x00;
	int86x( 0xD2, &r, &ro, &sr );

	return 0;
}

int MFM_fade( void )
{
	r.h.ah = 0x04;
	r.h.al = 0x06;
	int86x( 0xD2, &r, &ro, &sr );

	return 0;
}
