#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "msdrv4.h"
#include "..\common.h"
#include "..\extern.h"
#include "..\gmpv4sp.h"

char	*MSDRV4_opn = "*.OPN";
char	*MSDRV4_ssg = "*.SSG";

int MSDRV4_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0x61, 0, 2, id );

	if( memcmp( id, "MsDRV4", 6 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int MSDRV4_load( char *filename )
{
	struct find_t		ft;
	unsigned char far	*p;

	if( _dos_findfirst( MSDRV4_opn, _A_NORMAL, &ft ) == 0 )
	{
		/* OPN : ES:DI */
		r.x.ax = 0x2030;
		int86x( 0x61, &r, &ro, &sr );
		p = MK_FP(( unsigned short )ro.x.es, ( unsigned short )ro.x.di );
		_far_fileload( ft.name, p );
	}

	if( _dos_findfirst( MSDRV4_ssg, _A_NORMAL, &ft ) == 0 )
	{
		/* SSG : ES:DI */
		r.x.ax = 0x2020;
		int86x( 0x61, &r, &ro, &sr );
		p = MK_FP(( unsigned short )ro.x.es, ( unsigned short )ro.x.di );
		_far_fileload( ft.name, p );
	}

	/* Music : ES:DI */
	r.x.ax = 0x2000;
	int86x( 0x61, &r, &ro, &sr );
	p = MK_FP(( unsigned short )ro.x.es, ( unsigned short )ro.x.di );
	if( _far_fileload( filename, p ) == -1 ) return 1;

	return 0;
}

int MSDRV4_play( char *opt1, char *opt2 )
{
	r.x.ax = 0x2100;
	int86x( 0x61, &r, &ro, &sr );

	return 0;
}

int MSDRV4_stop( void )
{
	r.x.ax = 0x1000;
	int86x( 0x61, &r, &ro, &sr );

	return 0;
}

int MSDRV4_fade( void )
{
	r.x.ax = 0x2201;
	r.x.dx = 0xB4;
	int86x( 0x61, &r, &ro, &sr );

	return 0;
}
