#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "music60.h"
#include "..\common.h"
#include "..\extern.h"

int MUSIC60_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));
	_readvect( 0x60, 0, -8, id );

	if( memcmp( id, "MUSDRV7", 3 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int MUSIC60_load( char *filename )
{
	unsigned char far	*p = NULL;

	/* Music ES:AX */
	r.h.ah = 0x00;
	r.h.al = 0x80;
	int86x( 0x60, &r, &ro, &sr );
	p = MK_FP(( unsigned short )sr.es, ( unsigned short )ro.x.ax );

	if( _far_fileload( filename, p ) == -1 ) return 1;

	return 0;
}

int MUSIC60_play( char *opt1, char *opt2 )
{
	r.h.ah = 0x01;
	int86x( 0x60, &r, &ro, &sr );

	return 0;
}

int MUSIC60_stop( void )
{
	r.h.ah = 0x00;
	r.h.al = 0x00;
	int86x( 0x60, &r, &ro, &sr );

	return 0;
}

int MUSIC60_fade( void )
{
	r.h.ah = 0x00;
	r.h.al = 0x01;
	int86x( 0x60, &r, &ro, &sr );

	return 0;
}
