#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <memory.h>

#include "play5.h"
#include "..\common.h"
#include "..\extern.h"

int PLAY5_check( void )
{
	char	id1[16];
	char	id2[16];
	int		flag = 0;

	memset( id1, 0, sizeof( id1 ));
	memset( id2, 0, sizeof( id2 ));

	_readvect( 0xF2, 1, 0x102, id1 );
	_readvect( 0xF2, 1,    -8, id2 );

	if( memcmp( id1, "PLAY", 4 ) == 0 ) flag = 1;	/* PLAY3/4/5.COM */
	if( memcmp( id1, "music", 5 ) == 0 ) flag = 1;	/* MUSIC.COM */
	if( memcmp( id2, "MU", 2 ) == 0 ) flag = 1;		/* MU.COM */
	if( memcmp( id2, "SMUSIC", 6 ) == 0 ) flag = 1;	/* SMUSIC.COM */

	if( flag == 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int PLAY5_load( char *filename )
{
	long				filesize;
	unsigned char far	*p = NULL;

	if( strcmpi( filename, OPT[OPT_SE] ) == 0 ) return 0;

	filesize = _filesize( filename );
	if( filesize == -1 ) return 1;

	p = _far_calloc( filesize );
	_far_fileload( filename, p );

	/* Music : DS:BX */
	r.h.al = 0x00;
	sr.ds  = FP_SEG( p );
	r.x.bx = FP_OFF( p );
	int86x( 0xF2, &r, &ro, &sr );

	farfree( p );

	return 0;
}

int PLAY5_play( char *opt1, char *opt2 )
{
	long				filesize;
	unsigned char far	*p;

	if( opt1 == NULL ) return 0;

	filesize = _filesize( opt1 );
	if( filesize == -1 ) return 1;

	p = _far_calloc( filesize );
	_far_fileload( opt1, p );

	/* Music : DS:BX */
	r.h.al = 0x04;
	sr.ds  = FP_SEG( p );
	r.x.bx = FP_OFF( p );
/*
	if( opt2 == NULL ) r.x.bx = 0;
	else r.x.bx = atoi( opt2 );
*/
	int86x( 0xF2, &r, &ro, &sr );

	farfree( p );

	return 0;
}

int PLAY5_stop( void )
{
	r.h.al = 0x02;
	int86x( 0xF2, &r, &ro, &sr );

	return 0;
}

int PLAY5_fade( void )
{
	r.h.al = 0x03;
	r.x.bx = 0x0100;
	int86x( 0xF2, &r, &ro, &sr );

	return 0;
}
