#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "scbios.h"
#include "..\common.h"
#include "..\extern.h"

int SCBIOS_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));
	_readvect( 0x52, 1, 0x103, id );

	if( memcmp( id, "SCBIOS", 6 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int SCBIOS_load( char *filename )
{
	unsigned char far	*p = NULL;

	/* Music : DS:DX */
	r.h.al = 0x04;
	int86x( 0x52, &r, &ro, &sr );
	p = MK_FP(( unsigned short )ro.x.dx, ( unsigned short )ro.x.ax );

	if( _far_fileload( filename, p ) == -1 ) return 1;

	return 0;
}

int SCBIOS_play( char *opt1, char *opt2 )
{
	r.h.al = 0x00;
	r.h.ah = 0x4B;
	r.x.cx = 0x0000;
	r.x.dx = 0x19AD;
	int86x( 0x52, &r, &ro, &sr );

	return 0;
}

int SCBIOS_stop( void )
{
	r.h.al = 0x01;
	int86x( 0x52, &r, &ro, &sr );

	return 0;
}

int SCBIOS_fade( void )
{
	r.h.al = 0x02;
	r.h.cl = 0x08;
	int86x( 0x52, &r, &ro, &sr );

	return 0;
}
