#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "synthia.h"
#include "..\common.h"
#include "..\extern.h"

int SYNTHIA_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));
	_readvect( 0x60, 0, 4, id );

	if( memcmp( id, "synthia", 7 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int SYNTHIA_load( char *filename )
{
	unsigned char far	*p = NULL;

	/* Music : DS:DX */
	r.h.ah = 0x0F;
	int86x( 0x60, &r, &ro, &sr );
	p = MK_FP(( unsigned int)sr.ds, ( unsigned int )ro.x.dx );

	if( _far_fileload( filename, p ) == -1 ) return 1;

	return 0;
}

int SYNTHIA_play( char *opt1, char *opt2 )
{
	r.h.ah = 0x00;
	r.x.dx = 0x0000;
	int86x( 0x60, &r, &ro, &sr );

	return 0;
}

int SYNTHIA_stop( void )
{
	r.h.ah = 0x01;
	int86x( 0x60, &r, &ro, &sr );

	return 0;
}

int SYNTHIA_fade( void )
{
	r.h.ah = 0x02;
	r.h.al = 0x40;
	int86x( 0x60, &r, &ro, &sr );

	return 0;
}
