#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include <memory.h>

#include "trpschrn.h"
#include "..\common.h"
#include "..\extern.h"

unsigned char	TRPSCHRN_int = 0;
unsigned char	TRPSCHRN_type = 0;

/*
TRPSCHRN_type:
	0 : etc..
	1 : King Breeder
	2 : METAL ORANGE
*/

int TRPSCHRN_check( void )
{
	char	id1[16];
	char	id2[16];

	memset( id1, 0, sizeof( id1 ));
	memset( id2, 0, sizeof( id2 ));

	_readvect( 0xF1, 0,  2, id1 );
	_readvect( 0x2F, 1, -8, id2 );

	if( memcmp( id1, "OPERAHOUSE", 10 ) != 0 )
	{
		if( memcmp( id2, "TRPSCHR", 7 ) != 0 )
		{
			printf( MES[MES_DRVNOTFOUND], DRIVER_name );
			return 1;
		} else {
			_readvect( 0x2F, 0, 0x027B, id2 );
			if( memcmp( id2,"mʁn", 6 ) == 0 ) TRPSCHRN_type = 2;
			else TRPSCHRN_type = 1;
			TRPSCHRN_int = 0x2F;
		}
	} else {
		TRPSCHRN_type = 0;
		TRPSCHRN_int = 0xF1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int TRPSCHRN_load( char *filename )
{
	long				filesize;
	unsigned char far	*p = NULL;

	if( strcmpi( filename, OPT[OPT_SE] ) == 0 )
	{
		printf( INFO[INFO_LOAD], STR[STR_SE], 0L );
		return 0;
	}

	filesize = _filesize( filename );
	if( filesize == -1 ) return 1;

	p = _far_calloc( filesize );
	_far_fileload( filename, p );

	/* Music : CX:DX or DS:DX */
	switch( TRPSCHRN_type )
	{
		case 0:
			r.x.ax = 0x0000;
			r.x.cx = FP_SEG( p );
			break;
		case 1:
			r.x.ax = 0x5934;
			r.x.cx = FP_SEG( p );
			break;
		case 2:
			r.x.ax = 0x5934;
			sr.ds  = FP_SEG( p );
			break;
	}
	r.x.dx = FP_OFF( p );
	r.x.bx = 0x0002;
	int86x( TRPSCHRN_int, &r, &ro, &sr );

	farfree( p );

	return 0;
}

int TRPSCHRN_play( char *opt1, char *opt2 )
{
	if(( TRPSCHRN_type == 1 ) && ( opt1 != NULL )) return 0;

	if( TRPSCHRN_type == 0 || TRPSCHRN_type == 2 )
	{
		if( TRPSCHRN_type == 0 ) r.x.ax = 0x0000;
		else r.x.ax = 0x5934;
		if( opt1 != NULL )
		{
			/* se */
			r.x.bx = 0x0005;
			r.h.dl = atoi( opt1 );

			printf( INFO[INFO_NO], r.h.dl );
		} else {
			/* music */
			r.x.bx = 0x0003;
			r.x.dx = 0x0002;
		}
	} else {
		/* music */
		r.x.ax = 0x5934;
		r.x.bx = 0x0003;
		r.x.dx = 0x0002;
	}
	int86x( TRPSCHRN_int, &r, &ro, &sr );

	return 0;
}

int TRPSCHRN_stop( void )
{
	if( TRPSCHRN_type == 0 ) r.x.ax = 0x0000;
	else r.x.ax = 0x5934;
	r.x.bx = 0x0003;
	r.x.dx = 0x0003;
	int86x( TRPSCHRN_int, &r, &ro, &sr );

	return 0;
}

int TRPSCHRN_fade( void )
{
	if( TRPSCHRN_type == 0 ) r.x.ax = 0x0000;
	else r.x.ax = 0x5934;
	r.x.bx = 0x0003;
	r.x.dx = 0x0001;
	int86x( TRPSCHRN_int, &r, &ro, &sr );

	return 0;
}
